#! /usr/bin/perl
print "Content-type: text/html\n\n";

if ($ENV{"REQUEST_METHOD"} eq "POST") {
  read(STDIN, $datastring, $ENV{"CONTENT_LENGTH"});		
}
elsif (exists $ENV{"REQUEST_METHOD"}) {		# data from GET transaction (or HEAD or other)
  $datastring = $ENV{"QUERY_STRING"};
}
else {
  print "Offline execution detected\n";
  print "Please enter some data.\n";
  $datastring = <>;
  chomp $datastring;
  print "== data accepted == HTML output follows ==\n\n";
}

###decode######################################################
$datastring =~s/%0D%0A/\n/g;                    			#step to deal with line
																											#breaks in text areas
@nameValuePairs = split(/&/, $datastring);						#step 1
foreach $pair (@nameValuePairs) {
  ($name, $value) = split(/=/, $pair);								#step 2
  
  $name =~tr/+/ /;                                 		#step 3
  $name =~s/%([\da-fA-F]{2})/pack("C",hex($1))/eg; 		#step 3
  $value =~tr/+/ /;                                		#step 3
  $value =~s/%([\da-fA-F]{2})/pack("C",hex($1))/eg;		#step 3
  
  if(exists $formHash{$name}) {												#improved step 4,
    $formHash{$name} = $formHash{$name}.";".$value;		#now handles multiple
  }																										#select menus
  else {
    $formHash{$name} = $value;
  }   	
}
###done decoding###############################################

###global variables############################################
$file_life_span = 1; # in days
$cache_limit = 30;
$file_time_out = 3.0/24; # in days (3 hours)

$stateDir = "states/"; # where state files will go
$imageDir = "images/"; # URL of image directory

%stateHash=();

$inventory_table = "inventory";
$customers_table = "customers";
$orders_table = "orders";

use DBI;
$dbhandle = DBI->connect("DBI:mysql:cdstore", "stoyan", "stoyan") or
  &errorPage("Failure to connect to the cdstore database ". DBI->errstr());
  
###end global variables########################################

###app logic###################################################
if($formHash{"request"} eq "login_begin_shopping")	{&login_begin_shopping;}
elsif($formHash{"request"} eq "begin_shopping")		{&begin_shopping;}
elsif($formHash{"request"} eq "search_store")		{&search_store;}
elsif($formHash{"request"} eq "show_detail")		{&show_detail;}
elsif($formHash{"request"} eq "add_to_cart")		{&add_to_cart;}
elsif($formHash{"request"} eq "view_cart")			{&view_cart;}
elsif($formHash{"request"} eq "continue_shopping")	{&continue_shopping;}
elsif($formHash{"request"} eq "delete_item")		{&delete_item;}
elsif($formHash{"request"} eq "change_quantity")	{&change_quantity;}
elsif($formHash{"request"} eq "check_out")			{&check_out;}
elsif($formHash{"request"} eq "logon_for_checkout") {&logon_for_checkout;}
elsif($formHash{"request"} eq "confirm_order")		{&confirm_order;}
else												{&welcome_page("");}
###end app logic################################################



#################################################################
sub welcome_page { #takes an optional message parameter
 my $message = $_[0];
 print <<PAGE;
 <html><head><title>Music CD Store</title></head>
  <body>
   <h2>Welcome to the Music CD Store</h2>
    $message
    <form action="$ENV{SCRIPT_NAME}" method="GET">
     <b>You may either log in now</b><br/>
     Username: <input type="text" name="user" size="20"/><br/>
     Password: <input type="password" name="pass" size="20"/><br/>
     <input type="hidden" name="request" value="login_begin_shopping"/>
     <input type="submit" value="Login"/>
    </form>
    <b>or you may <a href="$ENV{SCRIPT_NAME}?request=begin_shopping">
       begin shopping and login later</a></b>
    <hr/>
    If you do not have an account with us, you may
    <a href="signup.cgi">sign up now</a> or sign up later.

 </body>
</html>
PAGE
}

#################################################################
sub dblogon {
  ### It is assumed that the columns are named "user" and "password".
  my($dbhandle, $table_name, $alleged_user, $alleged_pass) = @_;

  my $sql = "SELECT password FROM $table_name WHERE user = " .
               $dbhandle->quote($alleged_user);
  my $qObj = $dbhandle -> prepare($sql) or &errorPage("Failure to access user info.");
  $qObj -> execute() or &errorPage("Failure to access user/pass info.");
  my @row = $qObj->fetchrow_array();  ### one element array
  $qObj -> finish();
  if(@row){ ### so row exists, so user exists ###
     if($alleged_pass eq $row[0]) {
 			 return "yes";
     }
    else {
      return "Invalid password.";
    }
  }
  return "Invalid user.";
}


##############################################
sub errorPage {
 my $message = $_[0];

print<<ALL;
 <html><head><title>Server Error</title></head>
 <body>
  <h2>Server Error Encountered</h2>
   $message Please try again. If the problem persists, please notify the <a href="mailto:admin\@uweb.edu">webmaster</a>.
 </body>
 </html>
ALL

exit;   # terminate program since failure to open data file
}
#################################################################
sub write_state {
 my ($dir, $fileroot, %states) = @_;
 my $filename = "$fileroot.state";
 open(OUTFILE, ">$dir$filename") or &errorPage("Error writing to state file.");
 foreach $key (keys %states) {
 $value = &URLencode($states{$key});
 $name = &URLencode($key);
   print OUTFILE "$name=$value\n";
 }
 close(OUTFILE);
}
#################################################################
sub read_state {
 my ($dir, $fileroot, $time_out, $time_out_function, $time_out_message) = @_;
 my $filename = "$fileroot.state";

 if(((-M "$dir$filename") > $time_out) && ($time_out > 0)
                                       && (-e "$dir$filename")) {
    if($time_out_function) {
      &$time_out_function($time_out_message);
			exit;
    }
		else{
      	&errorPage("Your session has timed out");
    }
 }
 my $now = time;
 utime $now, $now, "$dir$filename";
 ### updates modification time without altering file contents

 open(INFILE, "<$dir$filename") or &errorPage("Error reading state file.");
 my @array =<INFILE>;
 close(INFILE);

 my %hash = ();
 foreach $line (@array) {
		chomp $line;
   	my ($key, $value) = split(/=/, $line, 2);
 		$key = &URLdecode($key);
 		$value = &URLdecode($value);
   	$hash{$key} = $value;
 }
 return %hash;
}

################################################################
sub URLencode {
  my $string = $_[0];
  $string =~ s/([^\w])/"%".sprintf("%02x", ord($1))/eg;
  return $string;
}
################################################################
sub URLdecode {
  my $string = $_[0];
  $string =~ tr/+/ /;
  $string =~ s/%([\da-fA-F]{2})/pack("C",hex($1))/eg;
  return $string;
}



sub get_long_id {
	# incoming $dir must contain a trailing /
	my ($dir, $cache_limit, $file_life_span) = @_;
  opendir(DIR, $dir) or &errorPage("Error Logging On 1.");
  my @files = readdir(DIR);
  closedir(DIR);

  if($#files >= $cache_limit) {
  	foreach $file (@files) {
    		if((-f "$dir$file") && ((-M "$dir$file") > $file_life_span)) {
    			unlink "$dir$file";  #delete the file
    		}
 		}
  	opendir(DIR, $dir) or &errorPage("Error Logging On 2.");
 		@files = readdir(DIR);
  	closedir(DIR);

  	if($#files >= $cache_limit) {
  		# should generate e-mail message to warn administrator (see Ssection 9.?)
  		&errorPage("Site busy. Please try again later.");
  	}
  }
	return &generate_random_string(32);
}



#################################################################
sub login_begin_shopping {
  my $result = &dblogon($dbhandle, $customers_table, $formHash{"user"}, $formHash{"pass"});
  if($result ne "yes") {
    &welcome_page("Logon failed ($result). Please try again.<br/>");
    exit;
  }

  my $sessionID = &get_long_id($stateDir, $cache_limit, $file_life_span);
  %stateHash = ("user"=>$formHash{"user"});
  &write_state($stateDir, $sessionID, %stateHash);

  print <<TOP;
 <html><head><title>Music Store</title></head>
  <body>
   <h2>You are now logged in as $stateHash{"user"}.</h2>
TOP

  print "Please search our collection.\n";
  &print_search_form($sessionID);

  print<<BOTTOM;
 </body></html>
BOTTOM
}



sub begin_shopping {
  my $sessionID = &get_long_id($stateDir, $cache_limit, $file_life_span);
  &write_state($stateDir, $sessionID); # empty state hash

  print <<TOP;
 <html><head><title>Music Store</title></head>
  <body>
   <h2>You will need to login later when you check out.</h2>
   Please search our collection
TOP

  &print_search_form($sessionID);

  print<<BOTTOM;
 </body></html>
BOTTOM
}

#################################################################
sub generate_random_string {
  my $n = $_[0];
  my $result = "";
  my @chars = (0..9, 'a'..'z', 'A'..'Z');
  my $which;
  for($i = 1 ; $i <= $n ; $i++) {
  	$which=int rand 62;
   $result = $result . $chars[$which];
  }
  return $result;
}
#################################################################
sub print_search_form {
  my ($sessionID, %info) = @_;
  my ($category, $artists, $album, $songs, $sortby) =
   ($info{"category"}, $info{"artists"}, $info{"album"}, $info{"songs"}, $info{"sortby"});

  if($category eq "") { $category="all"; }
  if($sortby eq "") { $sortby="artists"; }
  print<<FORMTOP;
  <form action="$ENV{SCRIPT_NAME}" method="GET">
    Category: <select name="category">
FORMTOP

  # determine the list of categories
  my $sql = "SELECT category FROM $inventory_table";
  my $qObj = $dbhandle -> prepare($sql) or &errorPage("DB: Failure to prepare.");
  $qObj -> execute() or &errorPage("DB: Failure to execute.");
  my @row;
  my %tempHash=();  # To de-duplicate the category names
  while(@row = $qObj->fetchrow_array()){
    foreach $c (split(/;/, $row[0])){
      $tempHash{lc $c}=1;
    }
  }
  $qObj -> finish();
  my @categories = sort keys %tempHash;
  foreach $v (("all", @categories)) {
    print '<option value="', $v, '"';
    if($category eq $v) {
      print ' selected="selected"';
    }
    print ">$v</option>\n";
  }

print <<FORMMID;
   </select><br />
   Artists:
   <input type="text" name="artists" value="$artists" size="30"/><br />
   Album:
   <input type="text" name="album" value="$album" size="30"/><br />
   Songs:
   <input type="text" name="songs" value="$songs" size="30"/><br />
   <input type="hidden" name="id" value="$sessionID"/>
   <input type="hidden" name="request" value="search_store"/>
   Sort by
FORMMID
  foreach $v (("artists", "album", "year")) {
    print '<input type="radio" name="sortby" value="', $v, '"';
    if($sortby eq $v) {
      print ' checked="checked"';
    }
    print "/>$v\n";
  }
  print<<FORMBOTTOM;
     <br /><input type="submit" value="Search for CDs matching these criteria"/>
  </form>
FORMBOTTOM
}




#################################################################
sub search_store {
  %stateHash = &read_state($stateDir, $formHash{"id"}, $file_time_out);
  my @search_results;

  if(exists $formHash{"start"}) { # if existing start, use previous search results
    @search_results = split(/&/, $stateHash{"search_results"});
    $stateHash{"start"} = $formHash{"start"};
   # $formHash{"artists"} = $stateHash{"artists"};
   # $formHash{"album"} = $stateHash{"album"};
   # $formHash{"songs"} = $stateHash{"songs"};
   # $formHash{"sortby"} = $stateHash{"sortby"};
  }
  else {
    @search_results = &search_inventory; # else do new search
    $stateHash{"search_results"} = join("&", @search_results);
    $stateHash{"start"}  = 1;
    $stateHash{"artists"} = $formHash{"artists"};
    $stateHash{"album"} = $formHash{"album"};
    $stateHash{"songs"} = $formHash{"songs"};
    $stateHash{"sortby"} = $formHash{"sortby"};
    $stateHash{"category"} = $formHash{"category"};
  }

  &write_state($stateDir, $formHash{"id"}, %stateHash);
  &display_results_page;
}

#################################################################
sub search_inventory {
  my @matches = ();
  my $category = lc $formHash{"category"};
  my $artists = $formHash{"artists"};
  my $album = $formHash{"album"};
  my $songs = $formHash{"songs"};
  my $sortby = lc $formHash{"sortby"};

  my @where = ();  # store an array of constraints
  if((lc $category ne "all") && ($category ne "")){
    push @where, "category LIKE " . $dbhandle->quote("\%$category\%");
  }
  if($artists ne "") {
    push @where, "artists LIKE " . $dbhandle->quote("\%$artists\%");
  }
  if($album ne "") {
    push @where, "album LIKE " . $dbhandle->quote("\%$album\%");
  }
  if($songs ne "") {
    push @where, "songs LIKE " . $dbhandle->quote("\%$songs\%");

  }
  my $where =  join(" and ", @where); # put constraints together
  if($where ne "") { $where = " WHERE $where";}

  my $sql = "SELECT stockID FROM $inventory_table $where ORDER BY $sortby ASC";
  my $qObj = $dbhandle->prepare($sql) or &errorPage("can't prepare.");
  $qObj->execute() or &errorPage("can't execute  ".$qObj->errstr());
  my $stockID;
  while(($stockID) = $qObj->fetchrow_array()) {
    push @matches, $stockID;
  }
  $qObj->finish();

  return @matches;
}


#################################################################
sub getInfo {
  my ($stockID, @columns) = @_;
  my $sql = "SELECT ".join(", ", @columns).
            " FROM $inventory_table WHERE stockID = $stockID";
  my $qObj = $dbhandle->prepare($sql) or &errorPage("Can't prepare.");

  $qObj->execute() or &errorPage("Can't execute. " . $qObj->errstr());
  my @info = $qObj->fetchrow_array(); # We only fetch the one row
  $qObj->finish();
  return @info;
}

#################################################################
sub display_results_page {
  my @matches = split(/&/, $stateHash{"search_results"});
  my $resultsPerPage = 2; # constant: number of results per page

  print <<TOP;
 <html><head><title>Music Store</title></head>
  <body>
   <h2>Search Results.</h2>
TOP
  &display_listing($stateHash{"start"}, $resultsPerPage, @matches);

  if( @matches > $resultsPerPage) {
    &print_search_links($stateHash{"start"}, scalar @matches, $resultsPerPage);
  }

  &print_search_form($formHash{"id"}, %stateHash);

  print "Click <a href=\"$ENV{SCRIPT_NAME}?request=view_cart&id=$formHash{id}\">",
          "here</a> to view shopping cart.<br/>\n";

  print<<BOTTOM;
 </body></html>
BOTTOM
}


#################################################################
sub display_listing {
  my ($start, $number, @matches) = @_;
  if(@matches <= 0) {
    print "Sorry, no matches.";
  }
  else{
    print "<ol start=\"$start\">\n";
    @matches = ("",@matches); # trick to match up index with counter
    for($k = $start; ($k < $start+$number) && ($k<=$#matches); $k++) {
      my ($album, $artists, $year, $price, $quantity) =
        &getInfo($matches[$k], "album", "artists", "year", "price", "quantity");
      print "<li>",
            "$album<br />",
            "$artists<br/>",
            "$year<br />\n",
            "Our low price: \$$price<br/>";

      print "<a href=\"$ENV{SCRIPT_NAME}?id=$formHash{'id'}&request=show_detail&stockID=$matches[$k]\">Show detail</a>\n";

      if($quantity > 0) {
        print <<FORM;
        	In stock.
          <form action="$ENV{SCRIPT_NAME}" method="GET">
          Quantity <input type="text" name="qty" value="1" size="3" maxlength="3"/>
          <input type="hidden" name="stockID" value="$matches[$k]"/>
          <input type="hidden" name="id" value="$formHash{'id'}"/>
          <input type="hidden" name="request" value="add_to_cart"/>
          <input type="submit"  value="Put into shopping cart"/>
          </form>
FORM
      }
      else {
        print "Out of stock. ";
      }
      print "</li>\n";
    }# end for
    print "</ol>\n";
  }# end else
}



#################################################################
sub print_search_links {
  my ($start, $matches, $resultsPerPage) = @_;
  my $nextstart;
  print "More result pages: \n";

  $nextstart = $start - $resultsPerPage;
  if($nextstart >= 1) {
    print "<a href=\"$ENV{SCRIPT_NAME}?id=$formHash{'id'}&request=search_store&start=$nextstart\">",
            "Previous", "</a>&nbsp;&nbsp;\n";
  }

  for($k = 1; $k < 1+$matches/$resultsPerPage; $k++) {
    $nextstart = ($k-1)*$resultsPerPage+1;
    if($nextstart == $start) {
      print "<b>$k</b>", "&nbsp;&nbsp;\n";
    }
    else {
      print "<a href=\"$ENV{SCRIPT_NAME}?id=$formHash{'id'}&request=search_store&start=$nextstart\">",
            $k, "</a>&nbsp;&nbsp;\n";
    }
  }

  $nextstart = $start + $resultsPerPage;
  if($nextstart <= $matches) {
    print "<a href=\"$ENV{SCRIPT_NAME}?id=$formHash{'id'}&request=search_store&start=$nextstart\">",
            "Next", "</a>&nbsp;&nbsp;\n";
  }
}


#################################################################
sub show_detail {
  my $instock = "In stock";
  my ($album, $artists, $year, $price, $quantity, $songlist, $desc, $image, $label) =
     &getInfo($formHash{"stockID"}, "album", "artists", "year", "price", "quantity",
          "songs", "description", "imagefile", "label");
  if($quantity<=0) {$instock = "Out of stock";}
  $songlist =~ s/;/<\/li>\n<li>/g;
  $songlist = "<ol><li>$songlist</li></ol>";
  print <<TOP;
 <html><head><title>Music Store</title></head>
  <body>
   <table>
    <tr>
     <td>
      <img src="$imageDir$image" height="100"/>
     </td>
     <td>
       $album<br/>
       $artists<br/>
       $year $label<br/>
       Our low price: \$$price<br/>
       $instock
     </td>
    </tr>
    <tr>
     <td colspan="2">
      Songs: $songlist
     </td>
    <tr>
    <tr>
     <td colspan="2">
      $desc
     </td>
    <tr>
   </table>
TOP
    if($quantity > 0){
         print <<FORM;
          <form action="$ENV{SCRIPT_NAME}" method="GET">
          Quantity <input type="text" name="qty" value="1" size="3" maxlength="3"/>
          <input type="hidden" name="stockID" value="$formHash{stockID}"/>
          <input type="hidden" name="id" value="$formHash{id}"/>
          <input type="hidden" name="request" value="add_to_cart"/>
          <input type="submit"  value="Put into shopping cart"/>
          </form>
FORM
       }

    print "Click <a href=\"$ENV{SCRIPT_NAME}?request=view_cart&id=$formHash{id}\">",
          "here</a> to view shopping cart.<br/>\n";

  print<<BOTTOM;
 </body></html>
BOTTOM

}

#################################################################
sub add_to_cart {
  %stateHash = &read_state($stateDir,$formHash{"id"}, $file_time_out);
  my $n = $formHash{"stockID"};
  my $qty = $formHash{"qty"};
  $qty = int $qty;
  if($qty < 1){ $qty = 1;}

  my %cartHash=();
  foreach $item (split(/&/, $stateHash{"cart"})) {
    my ($key, $value) = split(/=/, $item);
    $cartHash{$key} = $value;
  }
  if(exists $cartHash{$n}) {
    $cartHash{$n} = $cartHash{$n} + $qty;
  }
  else {
    $cartHash{$n} = $qty;
  }

  my @cart = ();
  foreach $key (sort keys %cartHash) {
    push @cart, "$key=$cartHash{$key}";
  }
  $stateHash{"cart"} = join("&", @cart);
  &write_state($stateDir, $formHash{"id"}, %stateHash);

  &display_cart_page($n);
}

#################################################################
sub display_cart_page {
  my $highlight_stockID=$_[0];
  print <<TOP;
 <html><head><title>Music Store</title></head>
  <body>
   <h2>Your shopping cart</h2>
   <table border=2>
    <tr>
     <th>Stock#</th>
     <th>Album</th>
     <th>Qty</th>
     <th>Unit price</th>
     <th>Subtotal</th>
     <th>To change qty</th>
     <th>To delete</th>
   </tr>
TOP

  my %cartHash=();
  my @items = split(/&/, $stateHash{"cart"});
  foreach $item (@items) {
    my ($stockID, $quantity) = split(/=/, $item);
    $cartHash{$stockID} = $quantity;
  }

  my $subtotal;
  my $total=0;
  foreach $n (sort keys %cartHash) {
    $color="";
    if($n eq $highlight_stockID) { $color='bgcolor="yellow"';}
    my ($album, $artists, $year, $price) =
     &getInfo($n, "album", "artists", "year", "price");
    $subtotal = $price*$cartHash{$n};
    $total = $total + $subtotal;
    $subtotal = sprintf "%.2f", $subtotal;
    print <<ITEM;
      <tr $color><td>$n</td>
      <td><a href="$ENV{SCRIPT_NAME}?id=$formHash{'id'}&request=show_detail&stockID=$n">
          $album</a><br/>
          by $artists, $year.
      </td>
      <td align="right">$cartHash{$n}</td>
      <td align="right">\$$price</td>
      <td align="right">\$$subtotal</td>
      <td>
        <form action="$ENV{SCRIPT_NAME}" method="GET">
        <input type="text" name="qty" size="3" maxlength="3" value="$cartHash{$n}"/>
        <input type="hidden" name="stockID" value="$n"/>
        <input type="hidden" name="id" value="$formHash{'id'}"/>
        <input type="hidden" name="request" value="change_quantity"/>
        <input type="Submit" value="Change"/>
        </form>
      </td>
      <td><a href="$ENV{SCRIPT_NAME}?request=delete_item&id=$formHash{'id'}&stockID=$n">
          Delete</a></td>
      </tr>
ITEM
  }
  $subtotal = sprintf "%.2f", $subtotal;
  print "</table>The total is \$$total.<br/>\n";
  if($stateHash{"cart"} ne "") {
    print<<FORM;
      <form action="$ENV{SCRIPT_NAME}" method="GET">
         <input type="hidden" name="id" value="$formHash{'id'}"/>
        <input type="hidden" name="request" value="check_out"/>
        <input type="Submit" value="Checkout"/>
      </form>
FORM
  	  }

  print<<BOTTOM;
   <a href="$ENV{SCRIPT_NAME}?request=continue_shopping&id=$formHash{'id'}">To continue shopping.</a>
  </body></html>
BOTTOM
}


#################################################################
sub view_cart {
  %stateHash = &read_state($stateDir,$formHash{"id"}, $file_time_out);
  &display_cart_page(""); # so no item is hightlighted
}
#################################################################
sub delete_item {
  %stateHash = &read_state($stateDir,$formHash{"id"}, $file_time_out);
  my $n = $formHash{"stockID"};
  my %cartHash=();
  foreach $item (split(/&/, $stateHash{"cart"})) {
    my ($key, $value) = split(/=/, $item);
    $cartHash{$key} = $value;
  }
  delete $cartHash{$n}; # removes the key

  my @cart = ();
  foreach $key (sort keys %cartHash) {
    push @cart, "$key=$cartHash{$key}";
  }
  $stateHash{"cart"} = join("&", @cart);
  &write_state($stateDir, $formHash{"id"}, %stateHash);
  &display_cart_page(""); # so no item is hightlighted
}

#################################################################
sub change_quantity {
  %stateHash = &read_state($stateDir,$formHash{"id"}, $file_time_out);
  my $n = $formHash{"stockID"};
  my %cartHash=();
  foreach $item (split(/&/, $stateHash{"cart"})) {
    my ($key, $value) = split(/=/, $item);
    $cartHash{$key} = $value;
  }

  my $qty = $formHash{"qty"};
  $qty = int $qty;
  if($qty < 1){ $qty = 1;}
  $cartHash{$n} = $qty;

  my @cart = ();
  foreach $key (sort keys %cartHash) {
    push @cart, "$key=$cartHash{$key}";
  }
  $stateHash{"cart"} = join("&", @cart);
  &write_state($stateDir, $formHash{"id"}, %stateHash);

  &display_cart_page($n); #hightlight change
}
#################################################################
sub continue_shopping {
  %stateHash = &read_state($stateDir,$formHash{"id"}, $file_time_out);
  &display_results_page;
}
#################################################################
sub check_out {
  %stateHash = &read_state($stateDir,$formHash{"id"}, $file_time_out);
  if($stateHash{"user"} eq "") {
    &display_logon_for_checkout;
    exit;
  }

  %userHash = &getAccountInfo($stateHash{"user"});
  print <<TOP;
 <html><head><title>Music Store</title></head>
  <body>
   <h2>Checking out...</h2>
   <table border=2>
    <tr>
     <th>Stock#</th>
     <th>Album</th>
     <th>Qty</th>
     <th>Unit price</th>
     <th>Subtotal</th>
   </tr>
TOP

  my %cartHash=();
  foreach $item (split(/&/, $stateHash{"cart"})) {
    my ($key, $value) = split(/=/, $item);
    $cartHash{$key} = $value;
  }
  my $subtotal;
  my $total=0;
  foreach $n (sort keys %cartHash) {
     my ($album, $artists, $year, $price) =
     &getInfo($n, "album", "artists", "year", "price");
    $subtotal = $price*$cartHash{$n};
    $total = $total + $subtotal;
    $subtotal = sprintf "%.2f", $subtotal;
    print <<ITEM;
      <tr><td>$n</td>
      <td><a href="$ENV{SCRIPT_NAME}?id=$formHash{id}&request=show_detail&stockID=$n">
          $album</a><br/>
          by $artists, $year.
      </td>
      <td align="right">$cartHash{$n}</td>
      <td align="right">\$$price</td>
      <td align="right">\$$subtotal</td>

      </tr>
ITEM
  }
  $shipping = 5.00; # for simplicity
  $total = sprintf "%.2f", $total+$shipping;
  print "</table>Shipping is \$$shipping.<br />\n",
        "The total is <b>\$$total</b>.\n",
        "<hr/>Please check your personal information.<table border=\"2\">\n";

  $userHash{"creditcard"} =~ s/.*(\d{4})/xxxx-xxxx-xxxx-$1/; #show only last 4 digits
  foreach $key (("name", "address1", "address2", "city", "state", "zip",
                 "country", "email", "phone", "creditcard")) {
    print "    <tr><td>$key</td><td>$userHash{$key}</td></tr>\n";
  }

  print <<BOTTOM;
   </table>
   We only show last 4 digits of credit card for security.
      <form action="$ENV{SCRIPT_NAME}" method="GET">
         <input type="hidden" name="id" value="$formHash{id}"/>
        <input type="hidden" name="request" value="confirm_order"/>
        <input type="Submit" value="Confirm purchase"/>
      </form>

   <a href="$ENV{SCRIPT_NAME}?request=continue_shopping&id=$formHash{id}">To continue shopping.</a>
  </body></html>
BOTTOM
}
#################################################################
sub getAccountInfo {
  my $user =$_[0];
  my @columns = ("name", "address1", "address2",  "city", "state", "zip",
                 "country", "email", "phone", "creditcard");
  my $sql = "SELECT " . join(", ", @columns).
            " FROM $customers_table WHERE user = " . $dbhandle->quote($user);
  my $qObj = $dbhandle->prepare($sql) or &errorPage("Can't prepare.");
  $qObj->execute() or &errorPage("Can't execute. " . $qObj->errstr());
  my $userHashREF = $qObj->fetchrow_hashref(); # We only fetch the one row as a hash reference
  $qObj->finish();
  return %$userHashREF; # Dereference the hash reference
}
#################################################################
sub confirm_order {
  %stateHash = &read_state($stateDir,$formHash{"id"}, $file_time_out);

  if($stateHash{"user"} eq "") {
    &display_logon_for_checkout;
    exit;
  }

  my $today = &currentDate;

  %userHash = &getAccountInfo($stateHash{"user"});

  my %cartHash=();
  my @items = split(/&/, $stateHash{"cart"});
  foreach $item (@items) {
    my ($stockID, $quantity) = split(/=/, $item);
    $cartHash{$stockID} = $quantity;
  }

  print <<TOP;
 <html><head><title>Music Store</title></head>
  <body>
   <h2>Thank you for your purchase.</h2>
   You have ordered the following on $today.
   <table border=2>
    <tr>
     <th>Stock#</th>
     <th>Album</th>
     <th>Qty</th>
     <th>Unit price</th>
     <th>Subtotal</th>
    </tr>
TOP

  my $subtotal;
  my $total=0;
  foreach $n (sort keys %cartHash) {
    my ($album, $artists, $year, $price) =
       &getInfo($n, "album", "artists", "year", "price");
    $subtotal = $price*$cartHash{$n};
    $total = $total + $subtotal;
    $subtotal = sprintf "%.2f", $subtotal;
    print <<ITEM;
      <tr><td>$n</td>
      <td><a href="$ENV{SCRIPT_NAME}?id=$formHash{'id'}&request=show_detail&stockID=$n">
          $album</a><br/>
          by $artists, $year.
      </td>
      <td align="right">$cartHash{$n}</td>
      <td align="right">\$$price</td>
      <td align="right">\$$subtotal</td>

      </tr>
ITEM
  }
  $shipping = 5.00; ### for simplicity
  $total = sprintf "%.2f", $total+$shipping;
  print "</table>Shipping is \$$shipping.<br />\n",
        "The total is <b>\$$total</b>.<br />\n";

  my $orderID = &makeOrder($stateHash{"user"}, $stateHash{"cart"}, $today, $total);
  $stateHash{"cart"} = "";
  &write_state($stateDir, $formHash{"id"}, %stateHash); # clear shopping cart

  print "Your order\# is <b>$orderID</b>.<br />\n",
        "<hr/>The items will be charged and shipped to the following.",
        "<table border=\"2\">\n";

  $userHash{"creditcard"} =~ s/.*(\d{4})/xxxx-xxxx-xxxx-$1/; #show only last 4 digits
  foreach $key (("name", "address1", "address2", "city", "state", "zip",
                 "country", "email", "phone", "creditcard")) {
    print "    <tr><td>$key</td><td>$userHash{$key}</td></tr>\n";
  }

  print <<BOTTOM;
   </table>
   We only show last 4 digits of credit card for security.<br/>
   <hr>
   <a href="$ENV{SCRIPT_NAME}?request=continue_shopping&id=$formHash{'id'}">To shop some more.</a>
  </body></html>
BOTTOM
}

#################################################################
sub makeOrder {
  my($user, $cart, $today, $total)=@_;
  my $status="neworder";
  ### Get new order number ####
  my $sql = "SELECT orderID FROM $orders_table ORDER BY orderID DESC";
  my $qObj = $dbhandle->prepare($sql) or &errorPage("Can't prepare.");
  $qObj->execute() or &errorPage("Error in processing order.".
     "<a href=\"$ENV{SCRIPT_NAME}?request=checkout&id=$formHash{id}\">Return to checkout.</a>");
  my ($orderID) = $qObj->fetchrow_array();
  $qObj->finish();
  if($orderID){
    $orderID++; ## increment max order ID by 1.
  }
  else{
    $orderID = 100; ### IF there are no existing order IDs, we will start a new one at 100.
  }

  $sql = "INSERT into $orders_table (orderID, user, cart, orderdate, status, total, balance) " .
     " VALUES ($orderID, '$user', '$cart', '$today', '$status', $total, $total)";
  $qObj = $dbhandle->prepare($sql) or &errorPage("Can't prepare.");
  $qObj->execute() or &errorPage("Error in processing order.".
     "<a href=\"$ENV{SCRIPT_NAME}?request=checkout&id=$formHash{id}\">Return to checkout.</a>");
  $qObj->finish();
  return $orderID;
}
#################################################################
sub currentDate {
my @timeParts=localtime;
  	my ($day, $month, $year) = ($timeParts[3],$timeParts[4],$timeParts[5]);
  	return ($month+1)."/".$day."/".($year+1900);
}
#################################################################
sub display_logon_for_checkout {
 my $message = $_[0];
 my $sessionID = $formHash{"id"};
 print <<PAGE;
 <html><head><title>Music CD Store</title></head>
  <body>
   <h2>Please log on to continue checking out Store</h2>
   $message
    <form action="$ENV{SCRIPT_NAME}" method="GET">
      Username: <input type="text" name="user" size="20"/><br/>
     Password: <input type="password" name="pass" size="20"/><br/>
     <input type="hidden" name="request" value="logon_for_checkout"/>
     <input type="hidden" name="id" value="$sessionID"/>
     <input type="submit" value="Login and checkout"/>
    </form>
    If you do not have an account with us, you may
    <a href="signup.cgi" target="_blank">sign up here (brings up new window)</a>.
 </body>
</html>
PAGE
}

#################################################################
sub logon_for_checkout {
 my $result = &dblogon($dbhandle, $customers_table, $formHash{"user"}, $formHash{"pass"});
 if($result ne "yes") {
    &display_logon_for_checkout("Logon failed ($result). Please try again.<br/>");
    exit;
 }
 %stateHash = &read_state($stateDir, $formHash{"id"}, $file_time_out);
 $stateHash{"user"} = $formHash{"user"};
 &write_state($stateDir, $formHash{"id"}, %stateHash);
 &check_out;
}



