#! /usr/bin/perl
print "Content-type: text/html\n\n";

if ($ENV{"REQUEST_METHOD"} eq "POST") {
  read(STDIN, $datastring, $ENV{"CONTENT_LENGTH"});		
}
elsif (exists $ENV{"REQUEST_METHOD"}) {		# data from GET transaction (or HEAD or other)
  $datastring = $ENV{"QUERY_STRING"};
}
else {
  print "Offline execution detected\n";
  print "Please enter some data.\n";
  $datastring = <>;
  chomp $datastring;
  print "== data accepted == HTML output follows ==\n\n";
}

###decode######################################################
$datastring =~s/%0D%0A/\n/g;                    			#step to deal with line
																											#breaks in text areas
@nameValuePairs = split(/&/, $datastring);						#step 1
foreach $pair (@nameValuePairs) {
  ($name, $value) = split(/=/, $pair);								#step 2
  
  $name =~tr/+/ /;                                 		#step 3
  $name =~s/%([\da-fA-F]{2})/pack("C",hex($1))/eg; 		#step 3
  $value =~tr/+/ /;                                		#step 3
  $value =~s/%([\da-fA-F]{2})/pack("C",hex($1))/eg;		#step 3
  
  if(exists $formHash{$name}) {												#improved step 4,
    $formHash{$name} = $formHash{$name}.";".$value;		#now handles multiple
  }																										#select menus
  else {
    $formHash{$name} = $value;
  }   	
}
###done decoding###############################################

###global variables############################################
$customers_table = "customers";

use DBI;
$dbhandle = DBI->connect("DBI:mysql:cdstore", "stoyan", "stoyan");  

###end global variables#########################################

###app logic####################################################
if($formHash{"request"} eq "new_user"){&new_user;}
else{&welcome_page;}
###end app logic################################################

#################################################################
sub welcome_page { 
 print <<TOP;
 <html><head><title>Music CD Store Sign up</title></head>
  <body>
   <h2>Use this page to sign up.</h2> 
    <form action="$ENV{SCRIPT_NAME}" method="POST">
     All fields are required except for Address2, which is for the
        second line of an address if needed.
     <table>
     <tr><td align="right">Desired Username:</td>
      <td><input type="text" name="new_user" size="20"/></td>
     </tr>
     <tr><td align="right">Desired Password:</td>
      <td><input type="password" name="new_pass" size="20"/></td>
     </tr>
     <tr><td align="right">Retype Password:</td>
      <td><input type="password" name="retype_pass" size="20"/></td>
     </tr>
TOP
  foreach $key (("name", "address1", "address2", "city", "state", "zip",
                 "country", "email", "phone", "creditcard")) {
    print '    <tr><td align="right">', ucfirst $key, ":</td>",
          '<td><input type="text" name="', $key, '" size="20"/></td></tr>', "\n";
  }

  print <<BOTTOM;
     </table>
     <input type="hidden" name="request" value="new_user"/>
     <input type="submit" value="Sign up"/>
    </form>
    <hr/>
     <a href="musicstore.pl">Go shopping now</a>
 </body>
</html>
BOTTOM
}

#######################################################################
sub change_password {
  # We leave this as an exercise...?
  if(!&logon("$userDataDir"."password.txt",
       $formHash{"user"}, $formHash{"pass"})) {
    &welcome_page("<b>Login incorrect.</b>");
    exit;
  }

  if($formHash{"new_pass"} ne $formHash{"retype_pass"}) {
    &welcome_page("<b>Retyped password does not match. Password not changed.</b>");
    exit;
  }

  &change_password_file("$userDataDir"."password.txt", 
       $formHash{"user"}, $formHash{"new_pass"});

 print <<PAGE;
 <html><head><title>Music CD Store Sign up</title></head>
  <body>
   <h2>Password changed successfully.</h2> 
     <a href="musicstore.pl">Go shopping now</a>
 </body>
</html>
PAGE
}

#######################################################################
sub change_password_file {
  my($file, $alleged_user, $new_pass) = @_;

  open(PASS, $file) or
    &errorPage("Failure to access user/pass info.");
  my($user, $pass, $line, @filearray);
  while($line = <PASS>) {
    chomp $line;
    ($user, $pass) = split(/:/, $line, 2);
    if(lc $alleged_user eq lc $user) {
      $line = $user.":".$new_pass;
    }
    push @filearray, $line."\n";  # put newline character back on
  }
  close(PASS);

  open(PASS, ">$file") or
    &errorPage("Failure to save user/pass info.");
  print PASS @filearray;
  close(PASS);
}

#######################################################################
sub new_user {
  my @required_form_keys = ("new_user", "new_pass", "name", "address1", 
           "city", "state", "zip", "country", "email", "phone", "creditcard");
  
  foreach $key (@required_form_keys) {
    if($formHash{$key} eq "") {
      &tryAgain("You did not fill in the $key field.");
    }
  }

  if($formHash{"new_pass"} ne $formHash{"retype_pass"}) {
    &tryAgain("<b>Retyped password does not match.</b>");
  }

  $formHash{"new_user"} =~ s/\W//g; # Delete all nonalphanumeric characters;
  $formHash{"new_user"} = lc $formHash{"new_user"};

  my $sql = "SELECT * FROM $customers_table WHERE user = '$formHash{new_user}'";
  my $qObj = $dbhandle->prepare($sql) or &errorPage("Can't prepare."); 
  $qObj->execute() or &errorPage("Can't execute. ".$qObj->errstr());
  if($qObj->fetchrow_array()){
    &tryAgain("The user name $new_user is already in use; please choose another user name.");
  }
  $qObj->finish();

  my @user_info_keys = ("new_user", "new_pass", "name", "address1", "address2", "city", 
     "state", "zip", "country", "email", "phone", "creditcard");
  my @quoted_array = ();
  foreach $k (@user_info_keys) {
    push @quoted_array, $dbhandle->quote($formHash{$k});
  }

  $sql = "INSERT INTO $customers_table (user, password, name, address1, address2, ".
    "city, state, zip, country, email, phone, creditcard) VALUES ".
    "(". join(",", @quoted_array) . ")";
  $qObj = $dbhandle->prepare($sql) or &errorPage("Can't prepare."); 
  $qObj->execute() or &errorPage("Error saving new user information.");
  $qObj->finish();

  print <<PAGE;
 <html><head><title>Music CD Store Sign up</title></head>
  <body>
   <h2>Your new user information is added successfully.</h2> 
     <a href="musicstore.cgi">Go shopping now</a>
 </body>
</html>
PAGE

}
#######################################################################
sub tryAgain {
 my $message = $_[0]; # the incoming parameter, store in localized variable
 print<<ALL;
 <html>
 <head>
  <title>Please try again</title>
 </head>
 <body>
  <h3>$message</h3>
  Please use the back button and try again.
 </body>
 </html>
ALL
 exit;
}
#######################################################################
sub get_current_users {
  my $dir = $_[0];
  opendir(USERDIR, $dir) or
    &errorPage("Error reading users directory.");
  my @files = readdir(USERDIR);
  closedir(USERDIR);
  my @current_users = ();
  foreach $f (@files) {
    if($f =~/\A(.+)\.user\Z/i) {
      push @current_users, $1;
    }
  }
  return @current_users;
}

#######################################################################
#######################################################################
#######################################################################



sub logon {
  my($file, $alleged_user, $alleged_pass) = @_;
  open(PASS, $file) or
    &errorPage("Failure to access user/pass info.");
  my($user, $pass, $line);
  while($line = <PASS>) {
    chomp $line;
    ($user, $pass) = split(/:/, $line, 2);
    if((lc $alleged_user eq lc $user) && ($alleged_pass eq $pass)) {
      close(PASS);
      return 1;
    }
  }
  return 0;
}


sub errorPage {
 my $message = $_[0]; # the incoming parameter, store in localized variable
 print<<ALL;
 <html>
 <head>
  <title>Error encountered</title>
 </head>
 <body>
  <h1>Error Encountered</h1>
  <h3>$message</h3>
  Please try again, or report the problem to the webmaster.
 </body>
 </html>
ALL
 exit;
}
